Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.jar
Class JarFile

    java.lang.Object
      |
      +--java.util.zip.ZipFile
            |
            +--java.util.jar.JarFile

All Implemented Interfaces:
  java.util.zip.ZipConstants

public class JarFile
extends ZipFile

The `JarFile` class is used to read the contents of a JAR file from any file that can be opened with `java.io.RandomAccessFile`. It extends the class `java.util.zip.ZipFile` with support for reading an optional `Manifest` entry. The `Manifest` can be used to specify meta-information about the JAR file and its entries.

Since:
  1.2
See Also:
  `Manifest`, `ZipFile`, `JarEntry`

Field Summary
`static String` | `MANIFEST_NAME` The JAR manifest file name.

Fields inherited from class java.util.zip.ZipFile
`CENATT, CENATX, CENCOM, CENCRC, CENDSK, CENEXT, CENFLG, CENHDR, CENHOW, CENLEN, CENNAM, CENOFF, CENSIG, CENSIZ, CENTIM, CENVEM, CENVER, ENDCOM, ENDHDR, ENDOFF, ENDSIG, ENDSIZ, ENDSUB, ENDTOT, EXTCRC, EXTHDR, EXTLEN, EXTSIG, EXTSIZ, LOCCRC, LOCEXT, LOCFLG, LOCHDR, LOCHOW, LOCLEN, LOCNAM, LOCSIG, LOCSIZ, LOCTIM, LOCVER, OPEN_DELETE, OPEN_READ`

Constructor Summary
`JarFile(File file)` Creates a new `JarFile` to read from the specified `File` object.
`JarFile(File file, boolean verify)` Creates a new `JarFile` to read from the specified `File` object.
`JarFile(File file, boolean verify, int mode)` Creates a new `JarFile` to read from the specified `File` object in the specified mode.
`JarFile(String name)` Creates a new `JarFile` to read from the specified file `name`.
`JarFile(String name, boolean verify)` Creates a new `JarFile` to read from the specified file `name`.

Method Summary
`Enumeration` | `entries()` Returns an enumeration of the ZIP file entries.
`ZipEntry` | `getEntry(String name)` Returns the `ZipEntry` for the given entry name or `null` if not found.
`InputStream` | `getInputStream(ZipEntry ze)` Returns an input stream for reading the contents of the specified ZIP file entry.
`JarEntry` | `getJarEntry(String name)` Returns the `JarEntry` for the given entry name or `null` if not found.
`Manifest` | `getManifest()` Returns the JAR file manifest, or `null` if none.

Methods inherited from class java.util.zip.ZipFile
`close, finalize, getName, size`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### MANIFEST_NAME

    public static final String MANIFEST_NAME

  The JAR manifest file name.

  See Also:
    Constant Field Values

Constructor Detail

### JarFile

    public JarFile(String name)
            throws IOException

  Creates a new `JarFile` to read from the specified file `name`. The `JarFile` will be verified if it is signed.

Parameters:
  `name` - the name of the JAR file to be opened for reading
Throws:
  `IOException` - if an I/O error has occurred
  `SecurityException` - if access to the file is denied by the SecurityManager

### JarFile

    public JarFile(String name,
                   boolean verify)
            throws IOException

  Creates a new `JarFile` to read from the specified file `name`.

Parameters:
  `name` - the name of the JAR file to be opened for reading
  `verify` - whether or not to verify the JarFile if it is signed.
Throws:
  `IOException` - if an I/O error has occurred
  `SecurityException` - if access to the file is denied by the SecurityManager

### JarFile

    public JarFile(File file)
            throws IOException

  Creates a new `JarFile` to read from the specified `File` object. The `JarFile` will be verified if it is signed.

Parameters:
  `file` - the JAR file to be opened for reading
Throws:
  `IOException` - if an I/O error has occurred
  `SecurityException` - if access to the file is denied by the SecurityManager

### JarFile

    public JarFile(File file,
                   boolean verify)
            throws IOException

  Creates a new `JarFile` to read from the specified `File` object.

Parameters:
  `file` - the JAR file to be opened for reading
  `verify` - whether or not to verify the JarFile if it is signed.
Throws:
  `IOException` - if an I/O error has occurred
  `SecurityException` - if access to the file is denied by the SecurityManager.

### JarFile

    public JarFile(File file,
                   boolean verify,
                   int mode)
            throws IOException

  Creates a new `JarFile` to read from the specified `File` object in the specified mode. The mode argument must be either `OPEN_READ` or `OPEN_READ | OPEN_DELETE`.

Parameters:
  `file` - the JAR file to be opened for reading
  `verify` - whether or not to verify the JarFile if it is signed.
  `mode` - the mode in which the file is to be opened
Throws:
  `IOException` - if an I/O error has occurred
  `IllegalArgumentException` - If the `mode` argument is invalid
  `SecurityException` - if access to the file is denied by the SecurityManager

Method Detail

### getManifest

    public Manifest getManifest()
                         throws IOException

  Returns the JAR file manifest, or `null` if none.

  Returns:
    the JAR file manifest, or `null` if none
    `IOException`

### getJarEntry

    public JarEntry getJarEntry(String name)

  Returns the `JarEntry` for the given entry name or `null` if not found.

  Parameters:
    `name` - the JAR file entry name
  Returns:
    the `JarEntry` for the given entry name or `null` if not found.
  See Also:
    `JarEntry`

### getEntry

    public ZipEntry getEntry(String name)

  Returns the `ZipEntry` for the given entry name or `null` if not found.

  Overrides:
    `getEntry` in class `ZipFile`
  Parameters:
    `name` - the JAR file entry name
  Returns:
    the `ZipEntry` for the given entry name or `null` if not found
  See Also:
    `ZipEntry`

### entries

    public Enumeration entries()

  Returns an enumeration of the ZIP file entries.

  Overrides:
    `entries` in class `ZipFile`
  Returns:
    an enumeration of the ZIP file entries

### getInputStream

    public InputStream getInputStream(ZipEntry ze)
                               throws IOException

  Returns an input stream for reading the contents of the specified ZIP file entry.

  Overrides:
    `getInputStream` in class `ZipFile`
  Parameters:
    `ze` - the zip file entry
  Returns:
    an input stream for reading the contents of the specified ZIP file entry
  Throws:
    `ZipException` - if a ZIP format error has occurred
    `IOException` - if an I/O error has occurred
    `SecurityException` - if any of the JarFile entries are incorrectly signed.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.